<?php
namespace InternetGalerie\Igshop2\Domain\Model;

use InternetGalerie\Igshop2\Domain\Repository\PortopriceRepository;
use TYPO3\CMS\Core\Context\Context;
use TYPO3\CMS\Core\Utility\GeneralUtility;
/**
 * Porto
 */
class Porto extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * name
	 *
	 * @var string
	 */
	protected $name = '';

	/**
	 * code
	 *
	 * @var string
	 */
	protected $code = '';

	/**
	 * description
	 *
	 * @var string
	 */
	protected $description = '';

	/**
	 * price
	 *
	 * @var float
	 */
	protected $price = 0.0;

	/**
	 * size
	 *
	 * @var integer
	 */
	protected $size = 0;

	/**
	 * shipType
	 *
	 * @var string
	 */
	protected $shipType = '';

	/**
	 * priceEuro
	 *
	 * @var string
	 */
	protected $priceEuro = '';

    /**
     * countryAll
     *
     * @var bool
     */
    protected $countryAll = false;
    
	/**
	 * country
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Country>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $country = NULL;

	/**
	 * prices
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Portoprice>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $prices = NULL;

	/**
	 * __construct
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties
	 * Do not modify this method!
	 * It will be rewritten on each save in the extension builder
	 * You may modify the constructor of this class instead
	 *
	 * @return void
	 */
	protected function initStorageObjects() {
		$this->country = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->prices = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}

	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}

	/**
	 * Returns the description
	 *
	 * @return string $description
	 */
	public function getDescription() {
		return $this->description;
	}

	/**
	 * Sets the description
	 *
	 * @param string $description
	 * @return void
	 */
	public function setDescription($description) {
		$this->description = $description;
	}
	/**
	 * Returns the price
	 *
         * @param float $amount
         * @param integer $quantity
	 * @return float $price
	 */
	public function getCurrentDescription( $amount, $quantity) {
	  //echo($amount .','. $quantity);
	  $uidLang =  GeneralUtility::makeInstance(Context::class)->getPropertyFromAspect('language', 'id') > 0 ? $this->_getProperty('_localizedUid') : $this->getUid();

	  $portopriceRepository = GeneralUtility::makeInstance(PortopriceRepository::class);
	  $price = $portopriceRepository->findCurrentPrice($uidLang, $amount, $quantity);
	  //echo('<br />price='.$price .'('.($price ? 'j':'n').')');
	  return $price ? $price->getDescription() : $this->getDescription();
	}

	/**
	 * Returns the code
	 *
	 * @return string $code
	 */
	public function getCode() {
		return $this->code;
	}

	/**
	 * Sets the code
	 *
	 * @param string $code
	 * @return void
	 */
	public function setCode($code) {
		$this->code = $code;
	}

	/**
	 * Returns the price
	 *
	 * @return float $price
	 */
	public function getPrice() {
		return $this->price;
	}
	/**
	 * Returns the price
	 *
         * @param float $amount
         * @param integer $quantity
	 * @return float $price
	 */
	public function getCurrentPrice( $amount, $quantity) {
	  $uidLang =  GeneralUtility::makeInstance(Context::class)->getPropertyFromAspect('language', 'id') > 0 ? $this->_getProperty('_localizedUid') : $this->getUid();
      $portopriceRepository = GeneralUtility::makeInstance(PortopriceRepository::class);
	  $price = $portopriceRepository->findCurrentPrice($uidLang, $amount, $quantity);
	  //echo('<br />price='.$price .'('.($price ? 'j':'n').')');
	  return $price ? $price->getPrice() : $this->getPrice();
	}

	/**
	 * Returns the price
	 *
         * @param float $amount
         * @param integer $quantity
	 * @return float $price
	 */
	public function getCurrentPriceEuro( $amount, $quantity) {
	  $portopriceRepository = GeneralUtility::makeInstance(PortopriceRepository::class);
	  $price = $portopriceRepository->findCurrentPrice($this->getUid(), $amount, $quantity);
	  //echo('<br />price='.$price .'('.($price ? 'j':'n').')');
	  return $price ? $price->getPriceEuro() : $this->getPriceEuro();
	}

	/**
	 * Returns the price
	 *
         * @param float $amount
         * @param integer $quantity
	 * @return float $price
	 */
	public function getNextPrice( $amount, $quantity) {
          $uidLang =  GeneralUtility::makeInstance(Context::class)->getPropertyFromAspect('language', 'id') > 0 ? $this->_getProperty('_localizedUid') : $this->getUid();
	  $portopriceRepository = GeneralUtility::makeInstance(PortopriceRepository::class);
	  $price = $portopriceRepository->findNextPrice($uidLang, $amount, $quantity);
	  //echo('<br />price='.$price .'('.($price ? 'j':'n').')=' . $price->getAmountMin());
	  return $price ? $price->getAmountMin() : null;
	}

	/**
	 * Returns the price
	 *
         * @param float $amount
         * @param integer $quantity
	 * @return float $price
	 */
	public function getNextPriceEuro( $amount, $quantity) {
		$portopriceRepository = GeneralUtility::makeInstance(PortopriceRepository::class);
	  $price = $portopriceRepository->findNextPrice($this->getUid(), $amount, $quantity);
	  //echo('<br />price='.$price .'('.($price ? 'j':'n').')=' . $price->getAmountMin());
	  return $price ? $price->getAmountMin() : null;
	}

	/**
	 * Sets the price
	 *
	 * @param float $price
	 * @return void
	 */
	public function setPrice($price) {
		$this->price = $price;
	}

	/**
	 * Returns the size
	 *
	 * @return integer $size
	 */
	public function getSize() {
		return $this->size;
	}

	/**
	 * Sets the size
	 *
	 * @param integer $size
	 * @return void
	 */
	public function setSize($size) {
		$this->size = $size;
	}

	/**
	 * Returns the shipType
	 *
	 * @return string $shipType
	 */
	public function getShipType() {
		return $this->shipType;
	}

	/**
	 * Sets the shipType
	 *
	 * @param string $shipType
	 * @return void
	 */
	public function setShipType($shipType) {
		$this->shipType = $shipType;
	}

	/**
	 * Returns the priceEuro
	 *
	 * @return string $priceEuro
	 */
	public function getPriceEuro() {
		return $this->priceEuro;
	}

	/**
	 * Sets the priceEuro
	 *
	 * @param string $priceEuro
	 * @return void
	 */
	public function setPriceEuro($priceEuro) {
		$this->priceEuro = $priceEuro;
	}
    /**
     * Returns the countryAll
     *
     * @return bool $countryAll
     */
    public function getCountryAll()
    {
        return $this->countryAll;
    }

    /**
     * Sets the countryAll
     *
     * @param bool $countryAll
     * @return void
     */
    public function setCountryAll($countryAll)
    {
        $this->countryAll = $countryAll;
    }

    /**
     * Returns the boolean state of countryAll
     *
     * @return bool
     */
    public function isCountryAll()
    {
        return $this->countryAll;
    }

    
	/**
	 * Adds a Country
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Country $country
	 * @return void
	 */
	public function addCountry(\InternetGalerie\Igshop2\Domain\Model\Country $country) {
		$this->country->attach($country);
	}

	/**
	 * Removes a Country
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Country $countryToRemove The Country to be removed
	 * @return void
	 */
	public function removeCountry(\InternetGalerie\Igshop2\Domain\Model\Country $countryToRemove) {
		$this->country->detach($countryToRemove);
	}

	/**
	 * Returns the country
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Country> $country
	 */
	public function getCountry() {
		return $this->country;
	}

	/**
	 * Sets the country
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Country> $country
	 * @return void
	 */
	public function setCountry(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $country) {
		$this->country = $country;
	}


    /**
     * test if porto is for given country
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\Country $country is Porto valid for given country
     */
	public function hasCountry(\InternetGalerie\Igshop2\Domain\Model\Country $country) {
        if( $this->countryAll) {
            return true;
        }
            
        foreach( $this->country as $c) {
	    if($c->getUid()==$country->getUid())
	      return true;
	  }
	  return false;
	}

	/**
	 * Adds a Portoprice
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Portoprice $price
	 * @return void
	 */
	public function addPrice(\InternetGalerie\Igshop2\Domain\Model\Portoprice $price) {
		$this->prices->attach($price);
	}

	/**
	 * Removes a Portoprice
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Portoprice $priceToRemove The Portoprice to be removed
	 * @return void
	 */
	public function removePrice(\InternetGalerie\Igshop2\Domain\Model\Portoprice $priceToRemove) {
		$this->prices->detach($priceToRemove);
	}

	/**
	 * Returns the prices
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Portoprice> $prices
	 */
	public function getPrices() {
		return $this->prices;
	}

	/**
	 * Sets the prices
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Portoprice> $prices
	 * @return void
	 */
	public function setPrices(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $prices) {
		$this->prices = $prices;
	}

}