<?php
namespace InternetGalerie\Igshop2\Domain\Model;

use InternetGalerie\Igshop2\Domain\Repository\ProductRepository;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2015
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * ProductClass
 */
class ProductClass extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * name
	 *
	 * @var string
	 */
	protected $name = '';

    /**
     * externalId
     *
     * @var string
     */
    protected $externalId = '';

    /**
     * category
     *
     * @var string
     */
    protected $category = '';

	/**
	 * sorting
	 *
	 * @var integer
	 */
	protected $sorting = 0;
	

	/**
	 * active
	 *
	 * @var boolean
	 */
	protected $active = FALSE;
	
	/**
	 * withoutPorto
	 *
	 * @var boolean
	 */
	protected $withoutPorto = FALSE;
	
	/**
	 * hideInNavigation
	 *
	 * @var boolean
	 */
	protected $hideInNavigation = FALSE;

	/**
	 * Parent ID
	 *
	 * @var \InternetGalerie\Igshop2\Domain\Model\ProductClass
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $parent = NULL;

    /**
     * _languageUid
     * @var ?int
     */
    protected ?int $_languageUid;

    /**
     * _localizedUid
     * @var ?int
     */
    protected ?int $_localizedUid;

	/**
	 * Returns the sorting
	 *
	 * @return integer $sorting
	 */
	public function getSorting() {
	  return $this->sorting;
	}
	/**
	 * Sets the sorting
	 *
	 * @param integer $sorting
	 * @return void
	 */
	public function setSorting($sorting) {
	  $this->sorting = $sorting;

	}


	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}
    
    /**
     * Returns the externalId
     *
     * @return string $externalId
     */
	public function getExternalId(){
        return $this->externalId;
    }
    
    /**
     * Sets the externalId
     *
     * @param string $externalId
     * @return void
     */
    public function setExternalId($externalId){
        $this->externalId = $externalId;
    }
    
    /**
     * Returns the category
     *
     * @return string $category
     */
    public function getCategory(){
        return $this->category;
    }
    
    /**
     * Sets the category
     *
     * @param string $category
     * @return void
     */
    public function setCategory($category){
        $this->category = $category;
    }

	/**
	 * Returns the active
	 *
	 * @return boolean $active
	 */
	public function getActive() {
		return $this->active;
	}

	/**
	 * Sets the active
	 *
	 * @param boolean $active
	 * @return void
	 */
	public function setActive($active) {
		$this->active = $active;
	}

	/**
	 * Returns the boolean state of active
	 *
	 * @return boolean
	 */
	public function isActive() {
		return $this->active;
	}
	
	/**
	 * Returns the withoutPorto
	 *
	 * @return boolean $withoutPorto
	 */
	public function getWithoutPorto() {
		return $this->withoutPorto;
	}

	/**
	 * Sets the withoutPorto
	 *
	 * @param boolean $withoutPorto
	 * @return void
	 */
	public function setWithoutPorto($withoutPorto) {
		$this->withoutPorto = $withoutPorto;
	}

	/**
	 * Returns the boolean state of withoutPorto
	 *
	 * @return boolean
	 */
	public function isWithoutPorto() {
		return $this->withoutPorto;
	}
	
	/**
	 * Returns the hideInNavigation
	 *
	 * @return boolean $hideInNavigation
	 */
	public function getHideInNavigation() {
		return $this->withoutPorto;
	}

	/**
	 * Sets the hideInNavigation
	 *
	 * @param boolean $hideInNavigation
	 * @return void
	 */
	public function setHideInNavigation($hideInNavigation) {
		$this->hideInNavigation = $hideInNavigation;
	}

	/**
	 * Returns the boolean state of hideInNavigation
	 *
	 * @return boolean
	 */
	public function isHideInNavigation() {
		return $this->hideInNavigation;
	}

	/**
	 * Returns the parent
	 *
	 * @return \InternetGalerie\Igshop2\Domain\Model\ProductClass $parent
	 */
	public function getParent() {
		return $this->parent;
	}

	/**
	 * Sets the parent
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\ProductClass $parent
	 * @return void
	 */
	public function setParent(\InternetGalerie\Igshop2\Domain\Model\ProductClass $parent) {
		$this->parent = $parent;
	}
    
    /**
     * @param int $_languageUid
     * @return void
     */
    public function set_languageUid($_languageUid) {
      $this->_languageUid = $_languageUid;
    }

    /**
     * @return int
     */
    public function get_languageUid() {
      return $this->_languageUid;
    }
    /**
     * @param int $_localizedUid
     * @return void
     */
    public function set_localizedUid($_localizedUid) {
      $this->_localizedUid = $_localizedUid;
    }

    /**
     * @return int
     */
    public function get_localizedUid() {
      return $this->_localizedUid;
    }

    public function getProducts() {
		$productRepository = GeneralUtility::makeInstance(ProductRepository::class);
        return $productRepository->findByProductClass($this);
    }
}