/**
 * Module: Ig/IgShop2/MoveProduct
 * JavaScript for MoveProduct
 * @exports Ig/IgShop2/MoveProduct
 */
define(['jquery', 'jquery-ui/sortable'], function($) {


    // Confirmation box
    var MoveProduct = {
    };
    var MoveProduct = function($this) {
        var identifier = $this.data('identifier');
        var sortList;
        
        var i = 0;
        var value = '';
        
        $('tbody tr').each(function() {
            var productUid = $(this).data('uid');
            
            if(productUid > 0) {
                if(i++ > 0) {
                    value += ',';
                }
                value += productUid;
            }
        });
        sortList=value;
        var ajaxStatus = $.ajax(TYPO3.settings.ajaxUrls['sort_products_by_category'], {
            method: 'POST',
            data: {
                'identifier': identifier,
                'sortList': sortList
            },
            success: function(data, textStatus, jqXHR) {
                var identifierArr = identifier.split('-');
                var productUid = identifierArr[6];
                var $tr = $('tbody tr[data-uid="' + productUid + '"]');
                
                var $first = $('tbody tr:first');
                var $last = $('tbody tr:last');
                
                if($tr.hasClass('firstcol')) {
                    var $emptyButton = $tr.find('.btn.disabled');
                    var $firstSortingUp = $first.find('.sortingUp');
                    
                    $firstSortingUp.data('identifier', identifier);
                    
                    $first.find('.sortingDown').before($emptyButton);
                    $tr.find('.sortingDown').before($firstSortingUp);
                    
                    $tr.removeClass('firstcol');
                    $first.addClass('firstcol');
                }
                if($tr.hasClass('lastcol')) {
                    var $emptyButton = $tr.find('.btn.disabled');
                    var $lastSortingUp = $last.find('.sortingDown');
                    
                    $lastSortingUp.data('identifier', identifier);
                    
                    $last.find('.sortingUp').after($emptyButton);
                    $tr.find('.sortingUp').after($lastSortingUp);
                    
                    $tr.removeClass('lastcol');
                    $last.addClass('lastcol');
                }
                if($first.get(0) == $tr.get(0)) {
                    var $next = $tr.next();
                    if($next.hasClass('firstcol')) {
                        var $emptyButton = $next.find('.btn.disabled');
                        var $sortingUp = $tr.find('.sortingUp');
                        var $nextSortingDown = $next.find('.sortingDown');
                        
                        $sortingUp.data('identifier', $nextSortingDown.data('identifier'));
                        
                        $tr.find('.sortingDown').before($emptyButton);
                        $nextSortingDown.before($sortingUp);
                        
                        $next.removeClass('firstcol');
                        $tr.addClass('firstcol');
                    }
                }
                if($last.get(0) == $tr.get(0)) {
                    var $prev = $tr.prev();
                    if($prev.hasClass('lastcol')) {
                        var $emptyButton = $prev.find('.btn.disabled');
                        var $sortingDown = $tr.find('.sortingDown');
                        var $prevSortingUp = $prev.find('.sortingUp');
                        
                        $sortingDown.data('identifier', $prevSortingUp.data('identifier'));
                        
                        $tr.find('.sortingUp').after($emptyButton);
                        $prevSortingUp.after($sortingDown);
                        
                        $prev.removeClass('lastcol');
                        $tr.addClass('lastcol');
                    }
                }

                $tr.trigger('mouseout');
                $('.tooltip').remove();
            },
            error: function(xhr,status,error) {
                console.log(error);
            }
        });
    }
    $('table tbody').sortable({
        //containment: 'parent',
        handle: '.sortingDnd',
        helper: 'clone',
        zIndex: '4000',
        axis: 'y',
        tolerance: 'pointer',
        items: '> tr',
        forcePlaceholderSize: true,
        forceHelperSize: true,
        appendTo: document.body,
        stop: function(event, ui) {
	    MoveProduct(ui.item.find('.sortingDnd'));
	}
    });
    
    $('#categorySelect').on('change', function() {
        $('#categorySearch').submit();
    });

    TYPO3.MoveProduct=MoveProduct
    return MoveProduct;

});
